#!/bin/sh
# Calls yum with generated MRG repo configuration
# Req: mrg-repos.sh yum

usage () {
  echo "usage: $0 [-rVARIANT] [yum arguments]"
  echo "       where VARIANT is one of stable, candidate or devel."
  exit 1
}

test $# -eq 0 && usage

VARIANT="candidate"

variant () {
  case "$1" in
    c*) echo candidate;;
    d*) echo devel;;
    s*) echo stable;;
  esac
}

case $1 in
  -r*)
    REST=${1:2}
    if [ -n "$REST" ]
    then
      VARIANT=`variant ${1:2}`
    else
      shift
      if [ -n "$1" ]
      then
        VARIANT=`variant $1`
      else
        exit 1
      fi
    fi
    shift
    ;;
  -h*) usage;;
  *) : ;;
esac

a="/${0}"; a=${a%/*}; a=${a#/}; a=${a:-.}; BINDIR=`cd $a; pwd`

TMPDIR=`mktemp -d`
trap "rm -rf $TMPDIR" EXIT INT
TESTCONF=$TMPDIR/yum-mrg.conf
YUMOPTS="-c $TESTCONF"

{
  cat /etc/yum.conf
  echo "reposdir=$TMPDIR"
  cat /etc/yum.repos.d/*.repo
  $BINDIR/mrg-repos.sh
} > $TESTCONF

yum $YUMOPTS --enablerepo=mrg-$VARIANT $*
